<?php
/**
 * Created by PhpStorm.
 * User: rafaelporto
 * Date: 28/01/2016
 * Time: 13:11
 */

namespace Factory;


use Util\Utilities;

class Contato
{
    function createContato($cdCaso, $nrOrg, $dsRefeCont, $dsAberturaCaso, $dtHrContato, $nrContato, $cdFilial, $cdCliente, $idTpContato,
                            $cdSistema, $cdMotiCont, $cdOperInclusao, $nrParcInterlocutor, $nrParcNegocio,$nrseqcontato, $nrSeqSituacao = 1) {
        $entity = new \Teknisa\Model\Crm\Entities\Contato();
        $entity->setCdcaso($cdCaso);
        $entity->setNrseqcontato($nrseqcontato);
        $entity->setNrorg($nrOrg);
        $entity->setDsrefecont($dsRefeCont);
        $entity->setDsaberturacaso($dsAberturaCaso);
        $entity->setDthrcontato($dtHrContato);
        $entity->setNrcontato($nrContato);
        $entity->setCdfilial($cdFilial);
        $entity->setCdcliente($cdCliente);
        $entity->setIdtpcontato($idTpContato);
        $entity->setCdsistema($cdSistema);
        $entity->setCdmoticont($cdMotiCont);
        $entity->setCdoperinclusao($cdOperInclusao);
        $entity->setNrparcinterlocutor($nrParcInterlocutor);
        $entity->setNrparcnegocio($nrParcNegocio);

        // when creating a new contato, it will have "Aberto" as default "situação"
        // while there is no a better way to get such connection
        // because there is no control parameter on CRM_SITUACAO_CONTATO's table
        $entity->setNrseqsituacao($nrSeqSituacao);

        // default values to some properties
        $entity->setDtinclusao(new \DateTime());
        $entity->setDtultatu(new \DateTime());
        $entity->setIdgerafatura('SIM');

        return $entity;
    }

    function updateContato(\Teknisa\Model\Crm\Entities\Contato $entity, $dsRefeCont, $dsAberturaCaso, $cdSistema, $cdMotiCont) {
        $entity->setDsrefecont($dsRefeCont);
        $entity->setDsaberturacaso($dsAberturaCaso);
        $entity->setCdsistema($cdSistema);
        $entity->setCdmoticont($cdMotiCont);
        return $entity;
    }

    public function createArrayTicket($email,$nrclassificacaocaso,$nrtparvprod,$dsrefecont,$nrparcinterlocutor,
                                 $cdProduto,$dsaberturacaso,$cdnatucont,$nrarvoreprod,$dsarvoreprod,$cdmoticont){
        $contato = array();
        $contato['CDCASO'] = '';
        $contato['CDMOTICONT']= $cdmoticont;
        $contato['CDNATUCONT']= $cdnatucont;
        $contato['CDPRODUTO'] = $cdProduto;
        $contato['DSABERTURACASO'] = $dsaberturacaso;
        $contato['DSCAMINHO'] = null;
        $contato['DSREFECONT'] = $dsrefecont;
        $contato['EMAIL'] =  $email;
        $contato['IDORIGEMTICKET'] =  'PORTALCLIENTE';
        $contato['NRARVOREPROD'] =  $nrarvoreprod;
        $contato['NRCLASSIFICACAOCASO'] =  $nrclassificacaocaso;
        $contato['NRORG'] =  20;
        $contato['NRPARCINTERLOCUTOR'] =  $nrparcinterlocutor;
        $contato['NRSEQCONTATO'] =  '';
        $contato['NRTPARVPROD'] =  $nrtparvprod;
        $contato['NMPRODUTO'] =  $dsarvoreprod;
        $contato['__is_new'] =  true;
        $contato['changed'] =  true;
        return $contato;
    }

} 