export class WebSocketClient {
	private ws: WebSocket;

	constructor(url: string) {
		const urlTrue = url;
		const ws = new WebSocket(urlTrue);
		this.ws = ws;
		this.ws.onopen = function open() {
			console.log('connected');
			ws.send(`${Date.now()}`);
		};

		this.ws.onclose = function close() {
			console.log('disconnected');
		};

		this.ws.onmessage = function incoming(data) {
			console.log(data);
			console.log(`Roundtrip time: ${Date.now() - data.data} ms`);

			setTimeout(() => {
				ws.send(`${Date.now()}`);
			}, 500);
		};
		// this.ws.on('open', () => {
		// 	console.log('connect');
		// });
		// this.ws.on('message', (data: string) => {
		// 	console.log(`mesagem recebida ${data}`);
		// });
		console.log(`Listening at  ${urlTrue}`);
	}

	public send() {
		this.ws.send('cole');
	}
}
